### Ethernet packet handler for Ethernet simulator ###
#
# Public domain software
# (When using Python 2, part of this program must be commented/uncommented)
#
# Coded by Yasusi Kanada
# 2015-5-10


### Packet field access ###

def SMAC(packet):
    return packet[12:24].decode('utf-8')			# !! Python 3 !!
    # return packet[12:24]					# !! Python 2 !!

def DMAC(packet):
    return packet[0:12].decode('utf-8')				# !! Python 3 !!
    # return packet[0:12]					# !! Python 2 !!

def EtherType(packet):
    return packet[24:28].decode('utf-8')			# !! Python 3 !!
    # return packet[24:28]					# !! Python 2 !!

def Payload(packet):
    return packet[28:].decode('utf-8')				# !! Python 3 !!
    # return packet[28:]					# !! Python 2 !!


### Packet handler ###

def printPacket(packet, now, message):
    print(message, len(packet) // 2, "bytes  time:", now,
          "\n  SMAC:", SMAC(packet), " DMAC:", DMAC(packet), " Type:",
          EtherType(packet), "\n  Payload:", Payload(packet))	# !! Python 3 !!
    # print message, len(packet) // 2, "bytes  time:", now,
    #     "\n  SMAC:", SMAC(packet), " DMAC:", DMAC(packet), " Type:",
    # 	  EtherType(packet), "\n  Payload:", Payload(packet)	# !! Python 2 !!

